using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace UnifiedPOS.HardTotals.V1_4
{
    [ServiceContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public interface HardTotals
    {
        #region Version 1.1

        //
        // Common Properties
        //

		//[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetAutoDisableResponse")]
		//[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		//bool GetAutoDisable(string ConsumerID);

		//[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetAutoDisableResponse")]
		//[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		//void SetAutoDisable(string ConsumerID, bool AutoDisable);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapCompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapCompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        bool GetCapCompareFirmwareVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapPowerReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapPowerReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        PowerReporting GetCapPowerReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapStatisticsReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapStatisticsReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        bool GetCapStatisticsReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapUpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapUpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        bool GetCapUpdateFirmware(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapUpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapUpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        bool GetCapUpdateStatistics(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCheckHealthText", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCheckHealthTextResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        string GetCheckHealthText(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetClaimed", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetClaimedResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        bool GetClaimed(string ConsumerID);

		//[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDataCount", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDataCountResponse")]
		//[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		//int GetDataCount(string ConsumerID);

		//[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDataEventEnabledResponse")]
		//[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		//bool GetDataEventEnabled(string ConsumerID);

		//[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetDataEventEnabledResponse")]
		//[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		//void SetDataEventEnabled(string ConsumerID, bool DataEventEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        bool GetDeviceEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void SetDeviceEnabled(string ConsumerID, bool DeviceEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        bool GetFreezeEvents(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void SetFreezeEvents(string ConsumerID, bool FreezeEvents);

		//[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetOutputID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetOutputIDResponse")]
		//[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		//int GetOutputID(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        PowerNotification GetPowerNotify(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void SetPowerNotify(string ConsumerID, PowerNotification PowerNotify);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetPowerState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetPowerStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        PowerState GetPowerState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        ControlState GetState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDeviceControlDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDeviceControlDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        string GetDeviceControlDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDeviceControlVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDeviceControlVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        UposVersion GetDeviceControlVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDeviceServiceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDeviceServiceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        string GetDeviceServiceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDeviceServiceVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetDeviceServiceVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        UposVersion GetDeviceServiceVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetPhysicalDeviceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetPhysicalDeviceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        string GetPhysicalDeviceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetPhysicalDeviceName", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetPhysicalDeviceNameResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        string GetPhysicalDeviceName(string ConsumerID);

        //
        // Specific Properties			7 Properties
        //

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapErrorDetection", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapErrorDetectionResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		bool GetCapErrorDetection(string ConsumerID);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapSingleFile", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapSingleFileResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		bool GetCapSingleFile(string ConsumerID);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapTransactions", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetCapTransactionsResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		bool GetCapTransactions(string ConsumerID);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetFreeData", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetFreeDataResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		int GetFreeData(string ConsumerID);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetNumberOfFiles", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetNumberOfFilesResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		int GetNumberOfFiles(string ConsumerID);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetTotalsSize", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetTotalsSizeResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		int GetTotalsSize(string ConsumerID);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetTransactionInProgress", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetTransactionInProgressResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		bool GetTransactionInProgress(string ConsumerID);

        //
        // Common Methods
        //

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/Open", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/OpenResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        //void Open(string ConsumerID, string EndpointAddress);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/Close", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CloseResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        //void Close(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/Claim", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ClaimResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void Claim(string ConsumerID, int Timeout);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/Release", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ReleaseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void Release(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CheckHealth", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CheckHealthResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void CheckHealth(string ConsumerID, HealthCheckLevel Level);

		//[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ClearInput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ClearInputResponse")]
		//[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		//void ClearInput(string ConsumerID);

		//[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ClearInputProperties", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ClearInputPropertiesResponse")]
		//[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		//void ClearInputProperties(string ConsumerID);

		//[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ClearOutput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ClearOutputResponse")]
		//[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		//void ClearOutput(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/DirectIO", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/DirectIOResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        DirectIOData DirectIO(string ConsumerID, int Command, int Data, object Obj);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        CompareFirmwareResult CompareFirmwareVersion(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ResetStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ResetStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void ResetStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/RetrieveStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/RetrieveStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        string RetrieveStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void UpdateFirmware(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void UpdateStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        //
        // Specific Methods			15 Methods
        //

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/BeginTrans", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/BeginTransResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		void BeginTrans(string ConsumerID);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ClaimFile", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ClaimFileResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		void ClaimFile(string ConsumerID, int Handle, int Timeout);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CommitTrans", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CommitTransResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		void CommitTrans(string ConsumerID);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/Create", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CreateResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		int Create(string ConsumerID, string FileName, int Size, bool ErrorDetection);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/Delete", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/DeleteResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		void Delete(string ConsumerID, string FileName);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/Find", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/FindResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		TotalsFileInfo Find(string ConsumerID, string FileName);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/FindByIndex", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/FindByIndexResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		string FindByIndex(string ConsumerID, int Index);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/Read", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ReadResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		byte[] Read(string ConsumerID, int Handle, int Offset, int Count);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/RecalculateValidationData", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/RecalculateValidationDataResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		void RecalculateValidationData(string ConsumerID, int Handle);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ReleaseFile", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ReleaseFileResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		void ReleaseFile(string ConsumerID, int Handle);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/Rename", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/RenameResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		void Rename(string ConsumerID, int Handle, string NewName);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/Rollback", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/RollbackResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		void Rollback(string ConsumerID);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetAll", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetAllResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		void SetAll(string ConsumerID, int Handle, sbyte TargetValue);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ValidateData", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/ValidateDataResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		void ValidateData(string ConsumerID, int Handle);

		[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/Write", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/WriteResponse")]
		[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
		void Write(string ConsumerID, int Handle, byte[] Data, int Offset, int Count);

        #endregion

        #region Version 1.2

        //
        // Session Management
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetWSPOSVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetWSPOSVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        UposVersion GetWSPOSVersion();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GenerateConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GenerateConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        string GenerateConsumerID();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/OpenSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/OpenSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void OpenSession(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CloseSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CloseSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void CloseSession(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetProviderSessionTimeout", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetProviderSessionTimeoutResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        int GetProviderSessionTimeout(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/KeepAlive", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/KeepAliveResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void KeepAlive(string ConsumerID);

        //
        // Device Control
        // 

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/OpenDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/OpenDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void OpenDevice(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CloseDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/CloseDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void CloseDevice(string ConsumerID);

        //
        // Event Polling
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/PollForUPOSEvent", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/PollForUPOSEventResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        HardTotalsEvent PollForUPOSEvent(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetEventResponse", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/SetEventResponseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        void SetEventResponse(string ConsumerID, HardTotalsEventResponse EventResponse);

        #endregion

        #region Version 1.3

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetEncryptedClaimedConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/GetEncryptedClaimedConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/UposException", Name = "UposException")]
        string GetEncryptedClaimedConsumerID();

        #endregion

    }

    #region Version 1.1

    //
    // Common Data Types
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class DirectIOData
    {
        [DataMember]
        public int Data { get; set; }
        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class UposException
    {
        [DataMember]
        public ErrorCode ErrorCode { get; set; }
        [DataMember]
        public int ErrorCodeExtended { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class UposVersion
    {
        [DataMember]
        public int Major { get; set; }
        [DataMember]
        public int Minor { get; set; }
        [DataMember]
        public int Build { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class Statistic
    {
        [DataMember]
        public string Name { get; set; }
        [DataMember]
        public string Value { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/", ItemName = "Statistic")]
    public class StatisticList : List<Statistic>
    {
    }

    //
    // Common Enumerations
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public enum CompareFirmwareResult
    {
        [EnumMember]
        CFV_FIRMWARE_OLDER,
        [EnumMember]
        CFV_FIRMWARE_SAME,
        [EnumMember]
        CFV_FIRMWARE_NEWER,
        [EnumMember]
        CFV_FIRMWARE_DIFFERENT,
        [EnumMember]
        CFV_FIRMWARE_UNKNOWN,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public enum ControlState
    {
        [EnumMember]
        S_CLOSED,
        [EnumMember]
        S_IDLE,
        [EnumMember]
        S_BUSY,
        [EnumMember]
        S_ERROR,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public enum ErrorCode
    {
        [EnumMember]
        E_CLOSED,
        [EnumMember]
        E_CLAIMED,
        [EnumMember]
        E_NOTCLAIMED,
        [EnumMember]
        E_NOSERVICE,
        [EnumMember]
        E_DISABLED,
        [EnumMember]
        E_ILLEGAL,
        [EnumMember]
        E_NOHARDWARE,
        [EnumMember]
        E_OFFLINE,
        [EnumMember]
        E_NOEXIST,
        [EnumMember]
        E_EXISTS,
        [EnumMember]
        E_FAILURE,
        [EnumMember]
        E_TIMEOUT,
        [EnumMember]
        E_BUSY,
        [EnumMember]
        E_EXTENDED,
        [EnumMember]
        E_DEPRECATED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public enum HealthCheckLevel
    {
        [EnumMember]
        CH_INTERNAL,
        [EnumMember]
        CH_EXTERNAL,
        [EnumMember]
        CH_INTERACTIVE,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public enum PowerNotification
    {
        [EnumMember]
        PN_DISABLED,
        [EnumMember]
        PN_ENABLED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public enum PowerReporting
    {
        [EnumMember]
        PR_NONE,
        [EnumMember]
        PR_STANDARD,
        [EnumMember]
        PR_ADVANCED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public enum PowerState
    {
        [EnumMember]
        PS_UNKNOWN,
        [EnumMember]
        PS_ONLINE,
        [EnumMember]
        PS_OFF,
        [EnumMember]
        PS_OFFLINE,
        [EnumMember]
        PS_OFF_OFFLINE,
    }

    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public enum StatisticCategories
    {
        [EnumMember]
        All,
        [EnumMember]
        Manufacturer,
        [EnumMember]
        Upos,
    }
    */
    public class StatisticCategories
    {
        public const string All = "";
        public const string Manufacturer = "M_";
        public const string Upos = "U_";
    }

    //
    // Specific Data Types
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class TotalsFileInfo
    {
        [DataMember]
        public int Handle { get; set; }
        [DataMember]
        public int Size { get; set; }
    }

    //
    // Specific Enumerations
    //

    //
    // Constants
    //

    public class ExtendedError
    {
        public const int EFIRMWARE_BAD_FILE = 281;
        public const int ESTATS_ERROR = 280;
        public const int ESTATS_DEPENDENCY = 282;

		//
		// Specific
		//
		public const int ETOT_NOROOM = 201;
		public const int ETOT_VALIDATION = 202;
	}

    public class StatisticProperties
    {
        public const string CommunicationErrorCount = "CommunicationErrorCount";
        public const string DeviceCategory = "DeviceCategory";
        public const string FirmwareRevision = "FirmwareRevision";
        public const string HoursPoweredCount = "HoursPoweredCount";
        public const string InstallationDate = "InstallationDate";
        public const string Interface = "Interface";
        public const string ManufactureDate = "ManufactureDate";
        public const string ManufacturerName = "ManufacturerName";
        public const string MechanicalRevision = "MechanicalRevision";
        public const string ModelName = "ModelName";
        public const string SerialNumber = "SerialNumber";
        public const string UnifiedPOSVersion = "UnifiedPOSVersion";
    }

    public class Wait
    {
        public const int FOREVER = -1;
    }

    #endregion

    #region Version 1.2

    //
    // Event Polling
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class HardTotalsEvent
    {
        //[DataMember]
        //public DataEvent DataEvent { get; set; }
        [DataMember]
        public DirectIOEvent DirectIOEvent { get; set; }
        //[DataMember]
        //public ErrorEvent ErrorEvent { get; set; }
        //[DataMember]
        //public OutputCompleteEvent OutputCompleteEvent { get; set; }
        [DataMember]
        public StatusUpdateEvent StatusUpdateEvent { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class HardTotalsEventResponse
    {
        //[DataMember]
        //public DataEventResponse DataEventResponse { get; set; }
        [DataMember]
        public DirectIOEventResponse DirectIOEventResponse { get; set; }
        //[DataMember]
        //public ErrorEventResponse ErrorEventResponse { get; set; }
        //[DataMember]
        //public OutputCompleteEventResponse OutputCompleteEventResponse { get; set; }
        [DataMember]
        public StatusUpdateEventResponse StatusUpdateEventResponse { get; set; }
    }
    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class DataEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class DataEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }
    */
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class DirectIOEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int EventNumber { get; set; }
        [DataMember]
        public int Data { get; set; }
        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class DirectIOEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DirectIOData DirectIOData { get; set; }
    }
    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class ErrorEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public ErrorCode ErrorCode { get; set; }
        [DataMember]
        public int ErrorCodeExtended { get; set; }
        [DataMember]
        public ErrorLocus ErrorLocus { get; set; }
        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class ErrorEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class OutputCompleteEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        int OutputID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class OutputCompleteEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }
    */
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class StatusUpdateEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public class StatusUpdateEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }
    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public enum ErrorLocus
    {
        [EnumMember]
        EL_INPUT,
        [EnumMember]
        EL_INPUT_DATA,
        [EnumMember]
        EL_OUTPUT,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/HardTotals/")]
    public enum ErrorResponse
    {
        [EnumMember]
        ER_CLEAR,
        [EnumMember]
        ER_CONTINUEINPUT,
        [EnumMember]
        ER_RETRY,
    }
    */
    #endregion
}
